<?php

require_once 'Jabberd2.abstract.php';

class Ujabber extends Jabberd2
{
	private $set_presence;
	
	public final function __construct($pConnectionType = 'write')
	{	
		session_start();
		$this->_user     = $_SESSION['phpgw_info']['instant_messenger']['user'];
		$this->_pass     = $_SESSION['phpgw_info']['instant_messenger']['passwd'];
		$this->_server   = $_SESSION['phpgw_info']['instant_messenger']['name_jabber'];
		$this->_port     = $_SESSION['phpgw_info']['instant_messenger']['port_jabber'];
		$this->_resource = $_SESSION['phpgw_info']['instant_messenger']['resource_jabber'];
		$webjabber       = $_SESSION['phpgw_info']['instant_messenger']['webjabber'];
		session_write_close();

		if ( $this->connect($this->_user . '@' . $this->_server . '/' . $this->_resource . ':' . $this->_port, $this->_pass, $pConnectionType, $webjabber) )
			$this->connected = true;
		else
			$this->connected = false;
	}

	public final function __destruct()
	{
		$this->closeSocket();
		ob_end_flush();
		flush();
	}
	
	public final function isConnected()
	{
		return $this->connected;
	}

	public final function listen()
	{
		if ( !$this->isConnected() )
			return "disconnected";

		$this->get_last_access_user(array("jid" => "this"));	

		if ( strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') )
		{
			sleep(1);
			$xml = $this->readSocket();
			printf("%s", $xml);
		}
		else
		{
			ob_end_clean();
			ignore_user_abort(true);
			ob_start();

			$init = time();

			while ( ( connection_aborted() === 0 ) && time() - $init < 50 )
			{
				if( isset($xml) )	
					unset($xml);
			
				# read from server and write in the client
				$xml = $this->readSocket();
				$xml = ( strlen($xml) ) ? $xml : ' ';
				//$xml = ( strlen($xml) ) ? $xml : '_##_';
				printf("%s", $xml);
				ob_flush();
				flush();
				usleep(6000);
			}
		}
	}

	public final function SendMessage($pSendMessage)
	{
		if ( !$this->isConnected() )
			return "disconnected";

		$pSendMessage['body'] = stripslashes($pSendMessage['body']);

		$patterns = array('/&nbsp;| +/i', '/<br[^>]*>/i');
		$replace = array(' ', '<br />');
		$pSendMessage['body'] = preg_replace($patterns, $replace, $pSendMessage['body']);

 	        $_emotions  = '/<img[^>]*emotion="(\S+)?"[^>]*>/'; 
		$_emotions = preg_match_all($_emotions, $pSendMessage['body'], $emotions);

		foreach ( $emotions[0] as $key => $val )
			$emotions[0][$key] = '/' . addcslashes($val, './()[]{}^$*&?') . '/i';

		$pSendMessage['body'] = preg_replace($emotions[0], $emotions[1], $pSendMessage['body']);

		$to = $pSendMessage['to'];
		$type = "chat";
		$id = "";
		$content = array(
			"subject" => $pSendMessage['subject'] ? $pSendMessage['subject'] : "",
			"thread"  => $pSendMessage['thread'] ? $pSendMessage['thread'] : "",
			"body"    => $pSendMessage['body'] ? $pSendMessage['body'] : ""
		);

		$payload = "";

		if ($to && is_array($content))
		{
			if (!$id)
			{
				$id = $type . "_" . time();
			}

			$xml = "<message to='$to' type='$type' id='$id'>";

			if ($content['subject'])
			{
				$xml .= "<subject>" . $content['subject'] . "</subject>";
			}

			if ($content['thread'])
			{
				$xml .= "<thread>" . $content['thread'] . "</thread>";
			}

			//Linha abaixo dentro do padro xmpp, entretanto clientes como
			//o PSI no seguem o padro assim ocorre problemas de comunicao
			//descomentar e retirar a seguinte para voltar ao padrão assim
			//que possvel
			//24/10/2007 - problema verificado por usurios do SERPRO na
			//plataforma Windows ocorrendo tambm no cliente Linux
			//por Alexandre e Rodrigo

			//$xml .= "<html><body>" . $content['body'] . "</body></html>";

			//retirar a linha abaixo para voltar ao padrão conforme acima
			$xml .= "<body><![CDATA[" . htmlentities($content['body']) . "]]></body>";
			$xml .= $payload;
			$xml .= "</message>";
			unset($id);

			echo $xml;
			$this->writeSocket($xml);
			$this->close();
		}
		else
		{
			//$this->writeLog("ERROR: SendMessage() #2");
			return false;
		}
	}
}
?>
